<template lang="html">
  <div class="upload-media">
    <button class="collapsible-title-button"
      v-on:click="toggleExpanded()"
      v-bind:class="{ expanded: expanded, condensed: !expanded }">
      <span>{{ label.MEDIA }}</span>
    </button>
    <div v-show="expanded" class="content">
      <div class="thumbnail-section">
        <div class="section-title">{{ label.THUMBNAIL }}</div>
        <div class="thumbnail-container">
          <div class="thumbnail"></div>
        </div>
        <input id="thumbnail"
          ref="thumbnail"
          type="file"
          class="button" v-on:change="handleImageSelect($event, label.TYPE_THUMBNAIL)">
        <div v-if="$v.thumbnail.source.$invalid" class="error">
          <span v-if="!$v.thumbnail.source.required">Thumbnail is required.</span>
        </div>
      </div>
      <hr class="section-division">
      <div class="videos-section">
        <div class="section-title">{{ label.SUPPORTING_VIDEOS }}</div>
        <ul class="unstyled section-list">
          <li v-for="(video, index) in videos">
            <label :for="'video-' + (index + 1)">{{ label.VIDEO }} {{ index + 1 }}</label>
            <div class="section-list-item">
              <input :id="'video-' + (index + 1)" type="text"
                :placeholder="label.VIDEO_PLACEHOLDER"
                v-model="videosText[index]"
                v-on:keyup="handleVideoSelect(index)">
              <button v-on:click="removeVideo(index)"
                class="button closeBtn">{{ label.X }}</button>
            </div>
          </li>
        </ul>
        <button v-if="videos.length < maxVideos" v-on:click="addVideo()" class="button">{{ label.NEW_VIDEO }}</button>
      </div>
      <hr class="section-division">
      <div class="images-section">
        <div class="section-title">{{ label.SUPPORTING_IMAGES }}</div>
        <ul class="unstyled section-list">
          <li v-for="(image, index) in images">
            <label :for="'image_' + (index + 1)">{{ label.IMAGE }} {{ index + 1 }}</label>
            <div class="section-list-item">
              <input :id="'image_' + (index + 1)"
                type="file" v-on:change="handleImageSelect($event, label.TYPE_IMAGE, index)">
              <button v-on:click="removeImage(index)"
                class="button closeBtn">{{ label.X }}</button>
            </div>
          </li>
        </ul>
        <button v-if="images.length < maxImages" v-on:click="addImage()" class="button">{{ label.NEW_IMAGE }}</button>
      </div>
      <hr class="section-division" v-if="mediaList.length > 0">
      <div class="preview-section" v-if="mediaList.length > 0">
        <div class="section-title">{{ label.MEDIA_PREVIEW }}</div>
        <ep-game-media v-on:show="showMedia($event)"
          :list="mediaList"></ep-game-media>
      </div>
    </div>
    </div>
  </div>
</template>

<script>
import { mapState, mapActions } from 'vuex'
import { required } from 'vuelidate/lib/validators'

import GameMedia from '../Game/Media'

import { getVideoID, getVideoSrc, getVideoThumbnail } from '~/utils/youtube'
import { isValidYoutubeVideo } from '~/utils/formValidator'

export default {
  name: 'ep-upload-media',
  props: {
    initThumbnail: Object,
    initImages: Array,
    initVideos: Array
  },
  components: {
    'ep-game-media': GameMedia
  },
  data () {
    return {
      thumbnail: { source: '', file: '' },
      images: [],
      videos: [],
      videosText: [],
      maxVideos: 3,
      maxImages: 4,
      expanded: true,
      label: {
        MEDIA: 'MEDIA',
        THUMBNAIL: 'Thumbnail Image - 320x180 preferred',
        CHOOSE_IMAGE_FILE: 'Choose Image File',
        VIDEO: 'Video',
        NEW_VIDEO: 'New Video',
        SUPPORTING_VIDEOS: 'Supporting Videos',
        VIDEO_PLACEHOLDER: 'youtube.com/watch?v=videoID',
        IMAGE: 'Image',
        NEW_IMAGE: 'New Image',
        SUPPORTING_IMAGES: 'Supporting Images',
        MEDIA_PREVIEW: 'Media Preview',
        X: 'X',
        TYPE_THUMBNAIL: 'thumbnail',
        TYPE_IMAGE: 'image'
      }
    }
  },
  validations: {
    thumbnail: {
      source: {
        required
      }
    },
    images: {
      required
    },
    videos: {
      required
    }
  },
  mounted () {
    this.setThumbnail()
  },
  watch: {
    'initThumbnail.source' () {
      this.thumbnail.source = this.initThumbnail.source
    },
    initImages () {
      // Copy array values
      this.images = this.initImages.slice()
    },
    initVideos () {
      // Copy array values
      this.videos = this.initVideos.slice()
      this.videosText = this.videos.map(video => {
        return video.source
      })
    },
    'thumbnail.source' () {
      this.setThumbnail()
      this.$emit('thumbnail', this.thumbnail)
    },
    images () {
      this.$emit('images', this.images)
    },
    videos () {
      this.$emit('videos', this.videos)
    }
  },
  computed: {
    ...mapState('app', [
      'dialogTypes'
    ]),
    mediaList () {
      return this.videos.concat(this.images)
    }
  },
  methods: {
    ...mapActions('app', [
      'selectDialog'
    ]),
    addImage () {
      this.images.push({
        uid: '',
        type: 'image',
        thumbnail: '',
        source: '',
        file: ''
      })
    },
    removeImage (index) {
      this.images.splice(index, 1)
    },
    addVideo () {
      this.videos.push({
        uid: '',
        type: 'video',
        thumbnail: '',
        source: ''
      })
      this.videosText.push('')
    },
    removeVideo (index) {
      this.videos.splice(index, 1)
    },
    handleImageSelect (event, type, imageIndex) {
      event.preventDefault()

      let files = event.target.files

      for (let i = 0; i < files.length; i++) {
        let f = files[i]

        if (!f.type.match('image.*')) {
          continue
        }

        let reader = new window.FileReader()

        reader.onload = ((file) => {
          return (e) => {
            if (type === this.label.TYPE_THUMBNAIL) {
              this.thumbnail.source = e.target.result
              this.thumbnail.file = this.$refs.thumbnail.files[0]
            } else if (type === this.label.TYPE_IMAGE) {
              this.$set(this.images, imageIndex, {
                uid: this.images[imageIndex].uid,
                type: this.images[imageIndex].type,
                thumbnail: e.target.result,
                source: e.target.result,
                file: files[0]
              })
            }
          }
        })(f)

        reader.readAsDataURL(f)
      }
    },
    handleVideoSelect (videoIndex) {
      if (!isValidYoutubeVideo(this.videosText[videoIndex])) {
        return
      }
      let videoID = getVideoID(this.videosText[videoIndex])
      if (!videoID) {
        return
      }

      this.$set(this.videos, videoIndex, {
        uid: this.videos[videoIndex].uid,
        type: this.videos[videoIndex].type,
        thumbnail: getVideoThumbnail(videoID),
        source: getVideoSrc(videoID)
      })
    },
    toggleExpanded () {
      this.expanded = !this.expanded
    },
    setThumbnail () {
      this.$el.querySelector('.thumbnail').style.backgroundImage = `url('${this.thumbnail.source}')`
    },
    showMedia (media) {
      this.selectDialog({
        dialog: this.dialogTypes.media,
        data: media
      })
    }
  }
}
</script>

<style lang="scss" scoped>
@import '~assets/styles/input';
@import '~assets/styles/list';

.upload-media {
  display: block;
  position: relative;
  margin: 0;
  padding: 16px;
  border-right: none;
  border-left: none;
  border-bottom: 1px solid #dcdcdc;
}

.content {
  margin-top: 20px;
}

.section-title {
  margin-bottom: 8px;
}

ul.section-list {
  margin-top: 12px;
}

.section-list-item {
  input[type=text], input[type=file] {
    display: inline-block;
    width: 85%;
  }

  .closeBtn {
    float: right;
    display: inline-block;
    margin-top: 8px;
  }
}

.section-division {
  margin: 24px 0;
  border: none;
  border-bottom: 1px solid $dark-gray;
}

.thumbnail-container {
  display: block;
  position: relative;
  width: 100%;
  padding-bottom: 56.25%;
  background: $dark-gray;
}

.thumbnail {
  position: absolute;
  background-size: cover;
  background-position: center;
  background-repeat: no-repeat;
  width: 100%;
  bottom: 0;
  left: 0;
  top: 0;
  overflow: hidden;
}

.error {
  margin-bottom: 20px;
  color: #cc0000;

  &.signUpError {
    margin-top: 12px;
    margin-bottom: 0;
  }
}
</style>
